<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>27. Debugging and Profiling &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="The Python Standard Library" href="index.html" />
    <link rel="next" title="27.1. bdb — Debugger framework" href="bdb.html" />
    <link rel="prev" title="26.8. test — Regression tests package for Python" href="test.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="bdb.html" title="27.1. bdb — Debugger framework"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="test.html" title="26.8. test — Regression tests package for Python"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Python Standard Library</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="debugging-and-profiling">
<h1>27. Debugging and Profiling<a class="headerlink" href="#debugging-and-profiling" title="Permalink to this headline">¶</a></h1>
<p>These libraries help you with Python development: the debugger enables you to
step through code, analyze stack frames and set breakpoints etc., and the
profilers run code and give you a detailed breakdown of execution times,
allowing you to identify bottlenecks in your programs.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="bdb.html">27.1. <code class="docutils literal"><span class="pre">bdb</span></code> &#8212; Debugger framework</a></li>
<li class="toctree-l1"><a class="reference internal" href="faulthandler.html">27.2. <code class="docutils literal"><span class="pre">faulthandler</span></code> &#8212; Dump the Python traceback</a><ul>
<li class="toctree-l2"><a class="reference internal" href="faulthandler.html#dumping-the-traceback">27.2.1. Dumping the traceback</a></li>
<li class="toctree-l2"><a class="reference internal" href="faulthandler.html#fault-handler-state">27.2.2. Fault handler state</a></li>
<li class="toctree-l2"><a class="reference internal" href="faulthandler.html#dumping-the-tracebacks-after-a-timeout">27.2.3. Dumping the tracebacks after a timeout</a></li>
<li class="toctree-l2"><a class="reference internal" href="faulthandler.html#dumping-the-traceback-on-a-user-signal">27.2.4. Dumping the traceback on a user signal</a></li>
<li class="toctree-l2"><a class="reference internal" href="faulthandler.html#issue-with-file-descriptors">27.2.5. Issue with file descriptors</a></li>
<li class="toctree-l2"><a class="reference internal" href="faulthandler.html#example">27.2.6. Example</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pdb.html">27.3. <code class="docutils literal"><span class="pre">pdb</span></code> &#8212; The Python Debugger</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pdb.html#debugger-commands">27.3.1. Debugger Commands</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="profile.html">27.4. The Python Profilers</a><ul>
<li class="toctree-l2"><a class="reference internal" href="profile.html#introduction-to-the-profilers">27.4.1. Introduction to the profilers</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#instant-user-s-manual">27.4.2. Instant User&#8217;s Manual</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#module-cProfile">27.4.3. <code class="docutils literal"><span class="pre">profile</span></code> and <code class="docutils literal"><span class="pre">cProfile</span></code> Module Reference</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#the-stats-class">27.4.4. The <code class="docutils literal"><span class="pre">Stats</span></code> Class</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#what-is-deterministic-profiling">27.4.5. What Is Deterministic Profiling?</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#limitations">27.4.6. Limitations</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#calibration">27.4.7. Calibration</a></li>
<li class="toctree-l2"><a class="reference internal" href="profile.html#using-a-custom-timer">27.4.8. Using a custom timer</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="timeit.html">27.5. <code class="docutils literal"><span class="pre">timeit</span></code> &#8212; Measure execution time of small code snippets</a><ul>
<li class="toctree-l2"><a class="reference internal" href="timeit.html#basic-examples">27.5.1. Basic Examples</a></li>
<li class="toctree-l2"><a class="reference internal" href="timeit.html#python-interface">27.5.2. Python Interface</a></li>
<li class="toctree-l2"><a class="reference internal" href="timeit.html#command-line-interface">27.5.3. Command-Line Interface</a></li>
<li class="toctree-l2"><a class="reference internal" href="timeit.html#examples">27.5.4. Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="trace.html">27.6. <code class="docutils literal"><span class="pre">trace</span></code> &#8212; Trace or track Python statement execution</a><ul>
<li class="toctree-l2"><a class="reference internal" href="trace.html#command-line-usage">27.6.1. Command-Line Usage</a><ul>
<li class="toctree-l3"><a class="reference internal" href="trace.html#main-options">27.6.1.1. Main options</a></li>
<li class="toctree-l3"><a class="reference internal" href="trace.html#modifiers">27.6.1.2. Modifiers</a></li>
<li class="toctree-l3"><a class="reference internal" href="trace.html#filters">27.6.1.3. Filters</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="trace.html#programmatic-interface">27.6.2. Programmatic Interface</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="tracemalloc.html">27.7. <code class="docutils literal"><span class="pre">tracemalloc</span></code> &#8212; Trace memory allocations</a><ul>
<li class="toctree-l2"><a class="reference internal" href="tracemalloc.html#examples">27.7.1. Examples</a><ul>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#display-the-top-10">27.7.1.1. Display the top 10</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#compute-differences">27.7.1.2. Compute differences</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#get-the-traceback-of-a-memory-block">27.7.1.3. Get the traceback of a memory block</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#pretty-top">27.7.1.4. Pretty top</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="tracemalloc.html#api">27.7.2. API</a><ul>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#functions">27.7.2.1. Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#filter">27.7.2.2. Filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#frame">27.7.2.3. Frame</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#snapshot">27.7.2.4. Snapshot</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#statistic">27.7.2.5. Statistic</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#statisticdiff">27.7.2.6. StatisticDiff</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#trace">27.7.2.7. Trace</a></li>
<li class="toctree-l3"><a class="reference internal" href="tracemalloc.html#traceback">27.7.2.8. Traceback</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="test.html"
                        title="previous chapter">26.8. <code class="docutils literal"><span class="pre">test</span></code> &#8212; Regression tests package for Python</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="bdb.html"
                        title="next chapter">27.1. <code class="docutils literal"><span class="pre">bdb</span></code> &#8212; Debugger framework</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/debug.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="bdb.html" title="27.1. bdb — Debugger framework"
             >next</a> |</li>
        <li class="right" >
          <a href="test.html" title="26.8. test — Regression tests package for Python"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>